import { Component } from 'react';
interface InputProps {
    onChange: (inputTarget: any) => null;
    id: string;
    autoComplete: string;
    type: string;
    value: string;
    name: string;
    className: string;
    placeholder: string;
    pattern: string;
    defaultChecked: boolean;
    checked: boolean;
}
export default class Input extends Component<InputProps, InputProps> {
    static defaultProps: {
        onChange: () => void;
        id: string;
        type: string;
        value: string;
        name: string;
        className: string;
        placeholder: null;
        pattern: string;
    };
    constructor(props: InputProps);
    componentWillReceiveProps(props: InputProps): void;
    onChange(item: any): void;
    render(): JSX.Element;
}
export {};
